﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Security;

namespace DeskTopStateViewer
{
    public partial class MainPage : UserControl
    {
        static EndpointAddress address = new EndpointAddress("http://localhost/DeskTopStateManager/DeskTopStateService.svc");
        static PollingDuplexHttpBinding binding = new PollingDuplexHttpBinding(PollingDuplexMode.MultipleMessagesPerPoll);
        DeskTopStateService.DeskTopStateServiceClient proxy = new DeskTopStateService.DeskTopStateServiceClient(binding, address);
        DeskTopStateService.DeskTopStateType currentState = DeskTopStateService.DeskTopStateType.On;
        public MainPage()
        {
            InitializeComponent();
            
            this.comboBox1.Items.Add("選択してください");
            Type enumType = typeof(DeskTopStateService.DeskTopStateType);
            var fields = from field in enumType.GetFields()
                         where field.IsLiteral
                         select field;
            foreach (System.Reflection.FieldInfo item in fields)
            {
                this.comboBox1.Items.Add(item.GetValue(enumType).ToString());
            }
            this.comboBox1.SelectedItem = currentState.ToString();
            this.textBox1.Text = "user01";
            //自動生成されたプロキシクラスを生成する
            //DeskTopStateService.DeskTopStateServiceClient proxy = new DeskTopStateService.DeskTopStateServiceClient();
            //非同期呼び出しの結果を受け取るコールバック関数を定義
            //proxy.SetStateCompleted += new EventHandler<DeskTopStateService.SetStateCompletedEventArgs>(proxy_SetStateCompleted);
            //非同期呼び出しの実行、ID「666」は休暇として更新する（非同期結果にDayOffが返ってくる）
            proxy.SetStateAsync(this.textBox1.Text, currentState);
            this.label1.Content = "在席状況一覧：" + Environment.NewLine + this.textBox1.Text + "/" + currentState.ToString() + Environment.NewLine + "在席状態取得中...";
            proxy.GetStateReceived += new EventHandler<DeskTopStateService.GetStateReceivedEventArgs>(proxy_GetStateReceived);
            //proxy.GetStateCompleted += new EventHandler<DeskTopStateService.GetStateCompletedEventArgs>(proxy_GetStateCompleted);
            //proxy.GetStateAsync();
        }

        void proxy_GetStateReceived(object sender, DeskTopStateService.GetStateReceivedEventArgs e)
        {
            string result = ""; 
            if (e.Error == null) 
            { 
                foreach (DeskTopStateService.DeskTopStateSet state in e.state) 
                { 
                    result += state.ID + "/" + state.State + Environment.NewLine; 
                }
            } 
            this.label1.Content = "在席状況一覧：" + Environment.NewLine + result; 
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            Type enumType = typeof(DeskTopStateService.DeskTopStateType);
            System.Reflection.FieldInfo item = enumType.GetField(this.comboBox1.SelectedValue.ToString());
            currentState = (DeskTopStateService.DeskTopStateType)item.GetValue(enumType);
            proxy.SetStateAsync(this.textBox1.Text, currentState);
        }

        //void proxy_GetStateCompleted(object sender, DeskTopStateService.GetStateCompletedEventArgs e)
        //{
        //    this.label1.Content = "ログイン件数：" + e.Result.Count;
        //}

        //void proxy_SetStateCompleted(object sender, DeskTopStateService.SetStateCompletedEventArgs e)
        //{
        //    //非同期結果をプレースホルダに書き込み
        //    this.label1.Content = e.Result.ToString();
        //} 
    }
}
